{*******************************************}
{                                           }
{            FastReport v2.2                }
{                                           }
{ Exemple de cration de fonctions          }
{ (C) Guilbaud Olivier                      }
{        golivier@bigfoot.com               }
{                                           }
{ FastReport :(c) 1998-99 by Tzyganenko A.  }
{                                           }
{ Merci de transmettre vos commantaires &   }
{ modifications                             }
{Ceci est un FREEWARE il peut tre utilis  }
{librement.                                 }
{*******************************************}
{Histo :                                    }
{ 03/06/99 : Cration                       }

unit FR_OGFct;

interface


implementation
Uses FR_Pars,FR_Class; // Dclaration minimum

Type
  // Dclaration de notre objet
  TfrOGFunctionLibrary = class(TfrFunctionLibrary)
  public
    constructor Create; override;
    procedure DoFunction(FNo:Integer; p1,p2,p3:Variant; var val:String); override;
  end;

//**************************
//* TfrOGFunctionLibrary
//**************************
constructor TfrOGFunctionLibrary.Create;
begin
  inherited Create;

  // Ici, on dclare toutes les fonctions
  // que l'on va traiter (attention 3 caractres mini)
  with List do
  begin
    Add('POS');
    ADD('SQRT');
  end;
end;

// Ici on traite les fonctions
procedure TfrOGFunctionLibrary.DoFunction(FNo:Integer; p1,p2,p3:Variant;
  var val:String);
Var Par1,Par2: Variant;
    Resultat : Variant;
begin
 Try
  Case FNo of  //FNo reprsente le N d'index de la fct
               //dclare dans Create;
   0 : Begin   //Traitement de la fonction POS
         Par1:=VarToStr(Parser.Calc(p1)); //On utilise Parser car Px
         Par2:=VarToStr(Parser.Calc(P2)); // est peut tre une expression
         Resultat:=Pos(Par1,Par2);
       end;
   1 : Resultat:=SQRT(Parser.Calc(P1));  //Traitement de la fonction SQRT
  end;
 Except
  // Chane retourne en cas d'erreur
  Resultat:='Erreur fonction '+List.Strings[FNo];
 end;

 Val:=VarToStr(Resultat); // Le rsultat est une chane
end;

//********************************
// Initialisation des fonctions pour qu'elles soient
// prisent en charge par F.R.
Procedure DoInit;
Begin
  frRegisterFunctionLibrary(TfrOGFunctionLibrary);
end;

initialization
  DoInit;
end.
